#include "graf.cpp"
#include "iostream.h"

class cesta:public seznam {
  id_vrcholu *obsah;

 public:
  ohodnoceni_hran celkove;

  void pridat(id_vrcholu hodn) {
    obsah = new id_vrcholu;
    (*obsah) = hodn;
    seznam::pridat((void *)obsah);
  }

  void smazat(void *co) {
    delete (id_vrcholu*)(co);
  }

  void vypis(void) {
    konec();
    if (vrat() != NULL) {
      do {
	printf("%d - ", (*(id_vrcholu *)vrat()));
      } while (predchozi() != 0);
    }
    printf("(%d)\n", celkove);
  }
};

class stupen:public seznam {
  class obsah {
   public:
    id_vrcholu vrchol;
    id_vrcholu predchozi;
    ohodnoceni_hran hodnota;
  };

  obsah *pom;

 public:
  void pridat(id_vrcholu vrch, id_vrcholu pred, ohodnoceni_hran hod) {
    pom = new obsah;
    (*pom).vrchol = vrch;
    (*pom).hodnota = hod;
    (*pom).predchozi = pred;
    seznam::pridat((void *)pom);
  }

  void smazat(void *co) {
    delete (obsah*)(co);
  }

};

int najdi_vrchol(graf *g, vrchol **ids, id_vrcholu v) {
  (*g).start();
  if ((*g).vrat() == NULL) return 0;
  while ((*(vrchol *)((*g).vrat())).id != v) {
    if ((*g).dalsi() == 0) return 0;
  }
  (*ids) = (vrchol *)((*g).vrat());
  return 1;
}

int najdi_hranu(stupen *s, id_vrcholu v, ohodnoceni_hran o) {
  (*s).start();
  if ((*s).vrat() == NULL) return 0;
  while ( (*(stupen::obsah *)((*s).vrat())).vrchol != v) {
    if ((*s).dalsi() == 0) return 0;
  }
  if ( (*(stupen::obsah *)((*s).vrat())).hodnota <= o) return -1;
  else return 1;
}

int najdi_hranu(stupen *s, id_vrcholu *r, id_vrcholu v, id_vrcholu p) {
  (*s).start();
  if ((*s).vrat() == NULL) return 0;
  while ( (*(stupen::obsah *)((*s).vrat())).vrchol != v) {
    if ((*s).dalsi() == 0) return 0;
  }
  if ((*(stupen::obsah *)((*s).vrat())).predchozi == p) return 0;
  (*r) = (*(stupen::obsah *)((*s).vrat())).predchozi;
  return 1;
}

int sepis_hrany(stupen *s, graf *g, id_vrcholu v, ohodnoceni_hran o) {
  vrchol *id;
  hrana::obsah obsah;
  int je;


  if (najdi_vrchol(g, &id, v) == 0) return 0;

  (*id).hrany.start();
  if ((*id).hrany.vrat() == NULL) return 1;
  do {
    obsah = (*(hrana::obsah *)((*id).hrany.vrat()));
    je = najdi_hranu(s, obsah.kam, obsah.hodnota + o);
    if (je == 0) (*s).pridat(obsah.kam, v, o + obsah.hodnota);
    if (je == 1) {
      (*s).odebrata();
      (*s).pridat(obsah.kam, v, o + obsah.hodnota);
    }
  } while ((*id).hrany.dalsi() != 0);

  return 1;
}

int najdi(cesta *nej, graf *g, id_vrcholu poc, id_vrcholu kon) {
  stupen s;
  id_vrcholu v = poc;
  ohodnoceni_hran o = 0;
  void *aktual;

  if (sepis_hrany(&s, g, v, o) == 0) return 0;
  s.start();
  if (s.vrat() == NULL) return 0;
  do {
    aktual = s.geta();
    v = (*(stupen::obsah *)s.vrat()).vrchol;
    o = (*(stupen::obsah *)s.vrat()).hodnota;
    if (sepis_hrany(&s, g, v, o) == 0) return 0;
    s.seta(aktual);
  } while (s.dalsi() != 0);

  v = kon;

  if (najdi_hranu(&s, v, 0) == 0) return 0;
  (*nej).celkove = (*(stupen::obsah *)(s.vrat())).hodnota;

  do {
    (*nej).pridat(v);
  } while (najdi_hranu(&s, &v, v, poc));
  (*nej).pridat(poc);


  return 1;
}


void main(void) {
  clrscr();
  graf graf1(1);
  char *soubor, c = 0;

  printf("Zadej soubor s grafem (* je soubor graf.txt): ");
  cin >> soubor;
  if (soubor[0] == '*') soubor = "graf.txt";
  nacti_graf(&graf1, soubor);

  cesta *nej;
  id_vrcholu odkud = 1, kam = 2;
  do {
    printf("Zadej vychozi vrchol: ");
    cin >> odkud;
    printf("Zadej cilovy vrchol: ");
    cin >> kam;
    printf("\n");

    nej = new cesta;
    if (najdi(nej, &graf1, odkud, kam) == 0)
      printf("Spatne zadany pozadavek\n");
    else (*nej).vypis();
    delete nej;

    printf("\nKonec - ESC\n");
    c = getch();
  } while (c != 27);
}