#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <alloc.h>

class seznam {
/*  Obousmerny spojovy seznam se zarazkami */
/*  Prvni a posledni bunka (coz jsou zarazky) neobsahuji zadna data */
/*  Obsah bunky je ukazatel */

 private:
  class bunka {
    public:
     bunka *dalsi;
     bunka *predchozi;
     void *obsah;
  };
  bunka *prvni, *posledni, *nove, *aktual;
// ukazatel na prvni bunku, na posledni, pomocny ukazatel, ukazatel na aktualni bunku

 public:
  seznam(void) {
//    printf("seznam konst -- %lu bytes\n", (unsigned long) coreleft());
    nove = new bunka;
    prvni = nove;
    nove = new bunka;
    posledni = nove;
    (*prvni).dalsi = posledni;
    (*posledni).predchozi = prvni;
    aktual = NULL;
  }

  ~seznam(void) {
    while ((*prvni).dalsi != posledni) odebrat();
    delete prvni;
    delete posledni;
//    printf("seznam dest -- %lu bytes\n", (unsigned long) coreleft());
  }

  void start(void) {	// Nastavi aktualni pozici za prvni bunku
    aktual = (*prvni).dalsi;
    if (aktual == posledni) aktual = NULL;
  }

  void konec(void) {	// Nastavi aktualni pozici pred posledni bunku
    aktual = (*posledni).predchozi;
    if (aktual == prvni) aktual = NULL;
  }

  int dalsi(void) {	// Posune aktualni pozici na dalsi bunku a vraci 1
			// Pokud je to bunka posledni, neposune se a vraci 0
			// Pokud je seznam prazdny je aktualni pozice nastavena na NULL a vraci -1
    if (aktual != NULL) {
      if ((*aktual).dalsi != posledni) {
	aktual = (*aktual).dalsi;
	return 1;
      } else return 0;
    } else return -1;
  }

  int predchozi(void) { // Posune aktualni pozici na predchozi bunku a vraci 1
			// Pokud je to bunka prvni, neposune se a vraci 0
			// Pokud je seznam prazdny je aktualni pozice nastavena na NULL a vraci -1
    if (aktual != NULL) {
      if ((*aktual).predchozi != prvni) {
	aktual = (*aktual).predchozi;
	return(1);
      } else return 0;
    } else return -1;
  }

  void *vrat(void) {	// Vraci ukazatel na obsah aktualni bunky
			// Pokud je seznam prazdny, vraci NULL
    if (aktual != NULL) return((*aktual).obsah);
    else return NULL;
  }

  void pridat(void *obsah) {	// Prida na konec seznamu bunku a vlozi do ni obsah
				// Pokud byl seznam prazdny bude nova bunka aktualni
    nove = new bunka;
    (*nove).predchozi = (*posledni).predchozi;
    (*nove).dalsi = posledni;
    (*(*posledni).predchozi).dalsi = nove;
    (*posledni).predchozi = nove;
    (*nove).obsah = obsah;
    if (aktual == NULL) aktual = nove;
  }

  int odebrat(void) {	// Odebere predposledni bunku ze seznamu a vrati 1
			// Smaze i obsah
			// Pokud je odebirana polozka aktualni, nastavi se jako aktualni predchazejici
			// Pokud je seznam prazdny vrati -1
    nove = (*posledni).predchozi;
    if (aktual == nove) aktual = (*nove).predchozi;
    if (nove != prvni) {
      (*(*nove).predchozi).dalsi = posledni;
      (*posledni).predchozi = (*nove).predchozi;
      smazat((*nove).obsah);
      delete nove;
      return 1;
    } else return -1;
  }

  int odebrata(void) {	// Odebere aktualni bunku ze seznamu a vrati 1
			// Smaze i obsah
			// Pokud je seznam prazdny vrati -1
			// Posune aktualni na dalsi
    if (aktual != NULL) {
      nove = (*aktual).dalsi;
      (*nove).predchozi = (*aktual).predchozi;
      nove = (*aktual).predchozi;
      (*nove).dalsi = (*aktual).dalsi;
      smazat((*aktual).obsah);
      delete aktual;
      if ((nove == prvni)&((*nove).dalsi == posledni)) aktual = NULL;
      else {
	aktual = nove;
	dalsi();
      }
      return 1;
    } else return -1;
  }

  virtual void smazat(void *co) {
    delete co;
  };

  bunka *geta(void) {
    return aktual;
  }

  void seta(void *akt) {
    aktual = (bunka *)akt;
  }
};

typedef int id_vrcholu;
typedef int id_grafu;
typedef	int ohodnoceni_hran;

class hrana:public seznam {

 public:

  class obsah {

   public:
    id_vrcholu kam;
    ohodnoceni_hran hodnota;
  };

  obsah *nove, *pomoc;

  void pridat(obsah co) {
    nove = new obsah;
    (*nove) = co;
    seznam::pridat((void *)nove);
  }

  void smazat(void *co) {
    delete (obsah *)(co);
  }

  void pis(void) {
    start();
    do {
      pomoc = (obsah *)vrat();
      printf("kam %d, hodnota %d \n", (*pomoc).kam, (*pomoc).hodnota);
    } while (dalsi() != 0);
  }
};

class vrchol {

  hrana::obsah pomoc;

 public:
  id_vrcholu id;
  hrana hrany;

  vrchol(id_vrcholu setid) {
    id = setid;
  }

  vrchol(void) {
  }

  void pridat(id_vrcholu kam, ohodnoceni_hran hodnota) {
    pomoc.kam = kam;
    pomoc.hodnota = hodnota;
    hrany.pridat(pomoc);
  }

  void pis(void) {
    printf("vrchol: %d\nhrany:\n", id);
    hrany.pis();
  }
};

class graf:public seznam {
  id_grafu id;
  vrchol *pomoc;

 public:
  graf(id_grafu setid) {
    id = setid;
  }

  void pridat(id_vrcholu id) {
    pomoc = new vrchol(id);
    seznam::pridat((void *)pomoc);
    konec();
  }

  void smaz(void *co) {
    delete (vrchol *)(co);
  }

  void pridat_hranu(id_vrcholu id, ohodnoceni_hran hodnota) {
    pomoc = (vrchol *)vrat();
    (*pomoc).pridat(id, hodnota);
  }

  void pis(void) {
    pomoc = (vrchol *)vrat();
    (*pomoc).pis();
  }
};

#define EOL 10

int nacticislo(int *cislo, FILE *f) {
  int i, konec = 0, krok;
  unsigned char znak[5];

  i = 0;
  if (feof(f)) konec = 1;

  while (konec == 0) {
    znak[i] = fgetc(f);
    if ((znak[i] < 48) || (znak[i] > 57)) konec = -1;
    if (znak[i] == ':') konec = 3;
    if (znak[i] == '-') konec = 3;
    if (znak[i] == EOL) konec = 2;
    if (feof(f)) konec = 1;
    if (i >= 5) konec = -1;
    i ++;
  }

  if (i > 0) {
    i --;
    znak[i] = 0;
  }

  i --;
  (*cislo) = 0;
  krok = 1;
  for( ; i >= 0; i --) {
    (*cislo) += (znak[i]-48)*krok;
    krok *= 10;
  }

  return konec;
}

void nacti_graf(graf *g, unsigned char *soubor) {
 /*soubor ma strukturu:

vrchol:vrchol-hodnota

priklad:
1:3-4:3

 */
  FILE *f;
  int cislo, cislo1, cislo2, konec = 3;

  if ((f = fopen(soubor, "rt")) != NULL) {

    while (konec == 3) {
      konec = nacticislo(&cislo, f);
      (*g).pridat(cislo);
      while (konec == 3) {
	konec = nacticislo(&cislo1, f);
	konec = nacticislo(&cislo2, f);
	(*g).pridat_hranu(cislo1, cislo2);
      }
      if (konec == 2) konec = 3;
//      (*g).pis();
    }

  } else {
    printf("Nelze najit soubor %s", soubor);
    exit(0);
  }

  fclose(f);
}
